package com.hfkj.dao;

import com.hfkj.entity.BsGasOilPriceWeek;
import com.hfkj.entity.BsGasOilPriceWeekExample.Criteria;
import com.hfkj.entity.BsGasOilPriceWeekExample.Criterion;
import com.hfkj.entity.BsGasOilPriceWeekExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsGasOilPriceWeekSqlProvider {

    public String countByExample(BsGasOilPriceWeekExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_gas_oil_price_week");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsGasOilPriceWeekExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_gas_oil_price_week");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsGasOilPriceWeek record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_gas_oil_price_week");
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.VALUES("mer_no", "#{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getWeeks() != null) {
            sql.VALUES("weeks", "#{weeks,jdbcType=INTEGER}");
        }
        
        if (record.getOilType() != null) {
            sql.VALUES("oil_type", "#{oilType,jdbcType=INTEGER}");
        }
        
        if (record.getOilTypeName() != null) {
            sql.VALUES("oil_type_name", "#{oilTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.VALUES("oil_no", "#{oilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNoName() != null) {
            sql.VALUES("oil_no_name", "#{oilNoName,jdbcType=VARCHAR}");
        }
        
        if (record.getPriceOfficial() != null) {
            sql.VALUES("price_official", "#{priceOfficial,jdbcType=DECIMAL}");
        }
        
        if (record.getPriceGun() != null) {
            sql.VALUES("price_gun", "#{priceGun,jdbcType=DECIMAL}");
        }
        
        if (record.getPriceVip() != null) {
            sql.VALUES("price_vip", "#{priceVip,jdbcType=DECIMAL}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsGasOilPriceWeekExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("mer_id");
        sql.SELECT("mer_no");
        sql.SELECT("weeks");
        sql.SELECT("oil_type");
        sql.SELECT("oil_type_name");
        sql.SELECT("oil_no");
        sql.SELECT("oil_no_name");
        sql.SELECT("price_official");
        sql.SELECT("price_gun");
        sql.SELECT("price_vip");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_gas_oil_price_week");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsGasOilPriceWeek record = (BsGasOilPriceWeek) parameter.get("record");
        BsGasOilPriceWeekExample example = (BsGasOilPriceWeekExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_oil_price_week");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getWeeks() != null) {
            sql.SET("weeks = #{record.weeks,jdbcType=INTEGER}");
        }
        
        if (record.getOilType() != null) {
            sql.SET("oil_type = #{record.oilType,jdbcType=INTEGER}");
        }
        
        if (record.getOilTypeName() != null) {
            sql.SET("oil_type_name = #{record.oilTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.SET("oil_no = #{record.oilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNoName() != null) {
            sql.SET("oil_no_name = #{record.oilNoName,jdbcType=VARCHAR}");
        }
        
        if (record.getPriceOfficial() != null) {
            sql.SET("price_official = #{record.priceOfficial,jdbcType=DECIMAL}");
        }
        
        if (record.getPriceGun() != null) {
            sql.SET("price_gun = #{record.priceGun,jdbcType=DECIMAL}");
        }
        
        if (record.getPriceVip() != null) {
            sql.SET("price_vip = #{record.priceVip,jdbcType=DECIMAL}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_oil_price_week");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        sql.SET("weeks = #{record.weeks,jdbcType=INTEGER}");
        sql.SET("oil_type = #{record.oilType,jdbcType=INTEGER}");
        sql.SET("oil_type_name = #{record.oilTypeName,jdbcType=VARCHAR}");
        sql.SET("oil_no = #{record.oilNo,jdbcType=VARCHAR}");
        sql.SET("oil_no_name = #{record.oilNoName,jdbcType=VARCHAR}");
        sql.SET("price_official = #{record.priceOfficial,jdbcType=DECIMAL}");
        sql.SET("price_gun = #{record.priceGun,jdbcType=DECIMAL}");
        sql.SET("price_vip = #{record.priceVip,jdbcType=DECIMAL}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsGasOilPriceWeekExample example = (BsGasOilPriceWeekExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsGasOilPriceWeek record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_oil_price_week");
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getWeeks() != null) {
            sql.SET("weeks = #{weeks,jdbcType=INTEGER}");
        }
        
        if (record.getOilType() != null) {
            sql.SET("oil_type = #{oilType,jdbcType=INTEGER}");
        }
        
        if (record.getOilTypeName() != null) {
            sql.SET("oil_type_name = #{oilTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.SET("oil_no = #{oilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNoName() != null) {
            sql.SET("oil_no_name = #{oilNoName,jdbcType=VARCHAR}");
        }
        
        if (record.getPriceOfficial() != null) {
            sql.SET("price_official = #{priceOfficial,jdbcType=DECIMAL}");
        }
        
        if (record.getPriceGun() != null) {
            sql.SET("price_gun = #{priceGun,jdbcType=DECIMAL}");
        }
        
        if (record.getPriceVip() != null) {
            sql.SET("price_vip = #{priceVip,jdbcType=DECIMAL}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsGasOilPriceWeekExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}